package unraid;

import java.net.Authenticator;
import java.net.HttpURLConnection;
import java.net.PasswordAuthentication;
import java.net.URL;

public class Utility {

	public static String SpinUpDisks(String host, String user, String password){
		return makeUrlCall("http://"+host+"/update.htm?cmdSpinUpAll=Spin+Up", user, password);
	}
	
	public static String SpinDownDisk(String host, String user, String password){
		return makeUrlCall("http://"+host+"/update.htm?cmdSpinDownAll=Spin+Down", user, password);
	}
	
	protected static String makeUrlCall(String urlStr, String user, String password){
		String returnVal="NONE";
		try{
			Authenticator.setDefault(new UnraidAuthenticator(user, password));
			URL url = new URL(urlStr);
			HttpURLConnection connection = (HttpURLConnection)url.openConnection();
			connection.setRequestMethod("GET");
			connection.setFollowRedirects(false);
			connection.connect();
			returnVal=connection.getResponseCode() + "";
		}catch (Exception e){
			returnVal="FAIL";
		}
		return returnVal;
	}

	public static void main(String[] args){
		SpinUpDisks("192.168.11.50", "root", "sammy");
	}
	
	static class UnraidAuthenticator extends Authenticator{
		String user=null;
		String password=null;
		public UnraidAuthenticator(String user, String password){
			this.user=user;
			this.password=password;
		}
		@Override
		protected PasswordAuthentication getPasswordAuthentication() {
			return new PasswordAuthentication (user, password.toCharArray());
		}
	}
	
}
